%define pkgname gdm

Summary: The GNOME Display Manager
Name: %{pkgname}-220
Version: 2.20.11
Release: %mkrel 1
License: GPLv2+
Group: Graphical desktop/GNOME
URL: http://www.gnome.org/projects/gdm/
Source0: ftp://ftp.gnome.org/pub/GNOME/sources/gdm/%{pkgname}-%{version}.tar.bz2
Source2: gdm_48.png
Source3: gdm_32.png
Source4: gdm_16.png
Source5: gdm-consolekit.conf
Source6: 90-grant-audio-devices-to-gdm.fdi

# (fc) 2.2.2.1-1mdk change default configuration
Patch0: gdm-defaultconfig.patch
# (fc) 2.4.0.11-3mdk use xvt instead of xterm
Patch1: gdm-2.19.1-xvt.patch
# (fc) 2.6.0.6-3mdk use pam_timestamp for gdmsetup (Fedora)
# and  don't use deprecated pam_stack (blino)
# and use pam_namespace for xguest (tv)
Patch4: gdm-pam.patch
# (fc) 2.6.0.6-3mdk clean up xses if session was sucessfully completed (Fedora)
Patch5: gdm-2.19.0-cleanup-xses.patch
# (fc) 2.18.0-2mdv force TMPDIR to /tmp, fix a11y startup inside gdm (Mdv bug #23215)
Patch6: gdm-2.19.1-tmpdir.patch
# (fc) 2.19.7-2mdv fix path for gdmsetup .desktop with usermode
Patch7: gdm-2.20.2-usermode.patch
# (fc) 2.19.8-3mdv don't set GDM_LANG for default system locale (Mdv bug #31290)
Patch8: gdm-2.19.8-gdmlang.patch
# (fc) 2.20.1-3mdv don't force UTF-8 on zh locale, rely on default locale
Patch10: gdm-2.20.1-zhlocale.patch
# (fc) 2.20.3-3mdv improve face browser
Patch12: gdm-2.20.3-face.patch
# (fc) 2.20.4-3mdv grab translation from gtk+mdk for "Welcome to %n" until upstream has enough translations
Patch13: gdm-2.20.4-welcome.patch
Patch14: gdm-2.20.9-format-strings.patch
# (fc) 2.20.10-3mdv set root pixmap for background
Patch15: gdm-2.20.10-rootpixmap.patch
# (fc) 2.20.10-4mdv wait a little before restarting X server on reboot / shutdown (SUSE) (Mdv bug #53757)
Patch16: gdm-2.20.0-wait-for-restart.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-root

Provides: dm
Conflicts: gdm

Requires(pre):     rpm-helper
Requires(postun):  rpm-helper
Requires(post):	   scrollkeeper >= 0.3
Requires(postun):  scrollkeeper >= 0.3
Requires(post): desktop-common-data
Requires: pam >= 0.99.8.1-8mdv
Requires: setup >= 2.1.9-33mdk
Requires: sessreg
Requires: usermode
Requires: cdialog
Requires: zenity
# for XFdrake on failsafe fallback:
Requires: drakx-kbd-mouse-x11
Requires: xinitrc >= 2.4.14
# used for secure remote login
Suggests: openssh-clients
Suggests: openssh-askpass-gnome
#needed by patch13
Requires: menu-messages
BuildRequires: X11-static-devel
BuildRequires: x11-server-xorg
BuildRequires: x11-server-xephyr
BuildRequires: gettext
BuildRequires: libglade2.0-devel
BuildRequires: libgnomeui2-devel
BuildRequires: librsvg-devel
BuildRequires: pam-devel
BuildRequires: usermode
BuildRequires: scrollkeeper
BuildRequires: gnome-doc-utils
BuildRequires: automake1.9 intltool
BuildRequires: consolekit-devel
BuildRequires: libwrap-devel
BuildRequires: libaudit-devel
BuildRequires: zenity
#gw for running intltool scripts
BuildRequires: perl-XML-Parser


%description
Gdm (the GNOME Display Manager) is a highly configurable
reimplementation of xdm, the X Display Manager. Gdm allows you to log
into your system with the X Window System running and supports running
several different X sessions on your local machine at the same time.

%package Xnest
Summary: Xnest (ie embedded X) server for GDM
Group: %{group}
Requires: %{name} = %{version}
Requires: x11-server-xephyr

%description Xnest
Gdm (the GNOME Display Manager) is a highly configurable
reimplementation of xdm, the X Display Manager. Gdm allows you to log
into your system with the X Window System running and supports running
several different X sessions on your local machine at the same time.

This package add support for Xnest server in gdm

%prep
%setup -q -n %{pkgname}-%{version}

%patch0 -p1 -b .defaultconf
%patch1 -p1 -b .xvt
%patch4 -p1 -b .pam
%patch5 -p1 -b .cleanup_xses
%patch6 -p1 -b .tmpdir
%patch7 -p1 -b .usermode
%patch8 -p1 -b .gdmlang
%patch10 -p1 -b .zhlocale
%patch12 -p1 -b .face
%patch13 -p1 -b .welcome
%patch14 -p1 -b .format_string
%patch15 -p1 -b .rootpixmap
%patch16 -p1 -b .waitforrestart

%build

%configure2_5x --enable-console-helper --sysconfdir=%{_sysconfdir}/X11 \
  --disable-scrollkeeper --with-console-kit=yes --enable-secureremote=yes \
 --localstatedir=%{_var}/lib
%make

%install
rm -rf $RPM_BUILD_ROOT

%makeinstall_std PAM_PREFIX=%{_sysconfdir} 

# don't provide PreSession/PostSession, pam handle this
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/X11/PreSession/Default
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/X11/PostSession/Default

ln -s consolehelper $RPM_BUILD_ROOT%{_bindir}/gdmsetup
perl -pi -e "s^%{_sbindir}/^^" %buildroot%_datadir/applications/gdmsetup.desktop

mkdir -p $RPM_BUILD_ROOT%{_datadir}/hosts

mkdir -p  $RPM_BUILD_ROOT%{_liconsdir} $RPM_BUILD_ROOT%{_miconsdir}
cp %{SOURCE2} $RPM_BUILD_ROOT%{_liconsdir}/gdm.png
cp %{SOURCE3} $RPM_BUILD_ROOT%{_iconsdir}/gdm.png
cp %{SOURCE4} $RPM_BUILD_ROOT%{_miconsdir}/gdm.png

mkdir -p $RPM_BUILD_ROOT%{_datadir}/gdm/themes/mdv-nolist
ln -f -s ../../../mdk/dm/GdmGreeterTheme-nolist.desktop $RPM_BUILD_ROOT%{_datadir}/gdm/themes/mdv-nolist/GdmGreeterTheme.desktop
for i in disconnect.png languages.png sessions.png system.png mdk-gdm-nolist.xml screenshot-gdm-nolist.png ; do
 ln -f -s ../../../mdk/dm/$i $RPM_BUILD_ROOT%{_datadir}/gdm/themes/mdv-nolist/
done


mkdir -p $RPM_BUILD_ROOT%{_datadir}/PolicyKit/policy
install -m644 %{SOURCE6} $RPM_BUILD_ROOT%{_datadir}/PolicyKit/policy

%{find_lang} %{pkgname} --with-gnome --all-name
for omf in %buildroot%_datadir/omf/%pkgname/%pkgname-??*.omf;do 
echo "%lang($(basename $omf|sed -e s/%pkgname-// -e s/.omf//)) $(echo $omf|sed -e s!%buildroot!!)" >> %pkgname.lang
done

#config for ConsoleKit
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/dbus-1/system.d/
install -m644 %{SOURCE5} $RPM_BUILD_ROOT%{_sysconfdir}/dbus-1/system.d/gdm-ConsoleKit.conf

mkdir -p $RPM_BUILD_ROOT%{_var}/log/gdm $RPM_BUILD_ROOT%{_sysconfdir}/X11/dm/Sessions

#remove unpackaged files
rm -rf   $RPM_BUILD_ROOT%{_libdir}/gtk-2.0/modules/*.{la,a} \
  $RPM_BUILD_ROOT%{_sysconfdir}/X11/gdm/PostLogin/Default.sample \
  $RPM_BUILD_ROOT%{_datadir}/xsessions/gnome.desktop

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

%pre
%_pre_useradd gdm %{_var}/lib/gdm /bin/false
%_pre_groupadd xgrp gdm

%triggerpostun -- gdm < 2.8.0.0-2mdk
if [ -d %{_datadir}/gdm/themes/mdk.to_remove ]; then 
  rm -fr %{_datadir}/gdm/themes/mdk.to_remove
  ln -s -f ../../mdk/dm %{_datadir}/gdm/themes/mdk
fi
#replace changed paths in gdm.conf
sed -i -e "s^%_bindir/\(gdm[^ \t]\+\)^%_libexecdir/\1^g"  %{_sysconfdir}/X11/gdm/gdm.conf

%post
#needed to update old gdm without removing new theme
#is removed by triggerpostun
if [ "$1" = "2" -a ! -L %{_datadir}/gdm/themes/mdk ]; then 
 mv %{_datadir}/gdm/themes/mdk  %{_datadir}/gdm/themes/mdk.to_remove
else 
 if [ ! -L %{_datadir}/gdm/themes/mdk ]; then
  ln -s -f ../../mdk/dm %{_datadir}/gdm/themes/mdk
 fi
fi

if [ -f /%{_sysconfdir}/X11/xdm/Xsession -a ! -x /%{_sysconfdir}/X11/xdm/Xsession ]; then
	chmod +x /%{_sysconfdir}/X11/xdm/Xsession
fi
if [ -x /usr/sbin/chksession ]; then /usr/sbin/chksession -g || true; fi

%if %mdkversion < 200900
/sbin/ldconfig
%endif
%update_scrollkeeper
%{_sbindir}/gdm-safe-restart >/dev/null 2>&1 || :

%preun
if [ "$1" = "0" ]; then
 rm -f %{_datadir}/gdm/themes/mdk > /dev/null
fi

%postun
%{make_session}
%_postun_userdel gdm
%_postun_groupdel xgrp gdm
%if %mdkversion < 200900
/sbin/ldconfig
%endif
%clean_scrollkeeper

%files -f %{pkgname}.lang
%defattr(-, root, root)

%doc AUTHORS COPYING NEWS README gui/greeter/greeter.dtd
%_sysconfdir/dbus-1/system.d/*
%_bindir/gdm-dmx-reconnect-proxy
%_bindir/gdmdynamic
%_bindir/gdmsetup
%{_bindir}/gdmphotosetup
%{_bindir}/gdmflexiserver
%{_libexecdir}/gdmchooser
%{_libexecdir}/gdmgreeter
%{_libexecdir}/gdmlogin
%{_libexecdir}/gdmaskpass
%{_libexecdir}/gdmopen
%{_libexecdir}/gdmtranslate
%{_libexecdir}/gdm-ssh-session
%{_sbindir}/*
%dir %{_sysconfdir}/X11/gdm
%{_sysconfdir}/X11/gdm/XKeepsCrashing
%config(noreplace) %{_sysconfdir}/pam.d/gdm
%config(noreplace) %{_sysconfdir}/pam.d/gdmsetup
%config(noreplace) %{_sysconfdir}/pam.d/gdm-autologin
%config(noreplace) %{_sysconfdir}/security/console.apps/gdmsetup
%config(noreplace) %{_sysconfdir}/X11/gdm/custom.conf
%config(noreplace) %{_sysconfdir}/X11/gdm/locale.alias
%config(noreplace) %{_sysconfdir}/X11/gdm/Xsession
%dir %{_sysconfdir}/X11/dm
%dir %{_sysconfdir}/X11/dm/Sessions
%config(noreplace) %{_sysconfdir}/X11/gdm/PreSession
%config(noreplace) %{_sysconfdir}/X11/gdm/PostSession
%config(noreplace) %{_sysconfdir}/X11/gdm/PostLogin
%config(noreplace) %{_sysconfdir}/X11/gdm/Init
%config(noreplace) %{_sysconfdir}/X11/gdm/modules
%{_libdir}/gtk-2.0/modules/*.so
%{_datadir}/pixmaps/*
%{_datadir}/gdm
%{_datadir}/PolicyKit/policy/*
%dir %{_datadir}/hosts
%attr(1770, gdm, gdm) %dir %{_var}/lib/gdm
%dir %{_var}/log/gdm
%_datadir/icons/hicolor/*/apps/gdm*
%{_liconsdir}/*.png
%{_iconsdir}/*.png
%{_miconsdir}/*.png
%dir %{_datadir}/omf/%pkgname
%{_datadir}/omf/%pkgname/%pkgname-C.omf
%{_mandir}/man1/*
%dir %{_datadir}/xsessions
%{_datadir}/xsessions/ssh.desktop

%files Xnest
%defattr(-, root, root)
%{_bindir}/gdmthemetester
%{_bindir}/gdmXnestchooser
%{_bindir}/gdmXnest


%changelog
* Sun Jul 11 2010 Götz Waschk <waschk@mandriva.org> 2.20.11-1mdv2011.0
+ Revision: 550767
- new version

* Fri Apr 23 2010 Frederic Crozat <fcrozat@mandriva.com> 2.20.10-10mdv2010.1
+ Revision: 538305
- Replace the old hack to restart gdm with safe method

* Tue Apr 20 2010 Frederic Crozat <fcrozat@mandriva.com> 2.20.10-9mdv2010.1
+ Revision: 537225
- Update Patch0 to ensure Xft.dpi is set for gdm greeter (needed for HD screen with some graphic chipset)
- Finish renaming
- copy old gdm as gdm-220

* Mon Mar 15 2010 Oden Eriksson <oeriksson@mandriva.com> 2.20.10-8mdv2010.1
+ Revision: 519987
- rebuilt against audit-2 libs

* Fri Oct 23 2009 Frederic Crozat <fcrozat@mandriva.com> 2.20.10-7mdv2010.0
+ Revision: 459092
- Use new theme by default, disable beep when login is ready

* Fri Oct 02 2009 Thierry Vignaud <tv@mandriva.org> 2.20.10-6mdv2010.0
+ Revision: 452551
- patch 4: use pam_namespace for xguest

* Thu Sep 24 2009 Frederic Crozat <fcrozat@mandriva.com> 2.20.10-5mdv2010.0
+ Revision: 448195
- Patch16 (SUSE): wait a little before restarting X server on reboot / shutdown (Mdv bug #53757)

* Wed Sep 16 2009 Frederic Crozat <fcrozat@mandriva.com> 2.20.10-4mdv2010.0
+ Revision: 443562
- Fix package name for find_lang

* Mon Aug 31 2009 Frederic Crozat <fcrozat@mandriva.com> 2.20.10-3mdv2010.0
+ Revision: 422866
- Update patch0 with correct path for default background
- Patch15: set default background atom, to enable crossfading when starting GNOME

* Wed Mar 25 2009 Frederic Crozat <fcrozat@mandriva.com> 2.20.10-2mdv2009.1
+ Revision: 361028
- Update patch0 : default color for root window is now black

* Thu Mar 19 2009 Götz Waschk <waschk@mandriva.org> 2.20.10-1mdv2009.1
+ Revision: 357659
- new version
- update patch 0

* Mon Feb 16 2009 Frederic Crozat <fcrozat@mandriva.com> 2.20.9-2mdv2009.1
+ Revision: 340977
- Replace dependencies on ssh/ssh-askpass with suggests

* Fri Dec 19 2008 Götz Waschk <waschk@mandriva.org> 2.20.9-1mdv2009.1
+ Revision: 316083
- new version
- update patch 0
- add patch 14 to fix the format strings

* Wed Sep 03 2008 Götz Waschk <waschk@mandriva.org> 2.20.8-1mdv2009.0
+ Revision: 279943
- new version

* Tue Jul 08 2008 Pixel <pixel@mandriva.com> 2.20.7-2mdv2009.0
+ Revision: 232794
- %make_session is deprecated by make-session filetrigger, but it can't work for
  gdm/kdm since the conf file is in xinitrc, calling "chksession -g" by hand for
  now

* Tue Jul 01 2008 Götz Waschk <waschk@mandriva.org> 2.20.7-1mdv2009.0
+ Revision: 230454
- new version
- drop patch 14
- update license

* Tue Jun 24 2008 Frederic Crozat <fcrozat@mandriva.com> 2.20.6-3mdv2009.0
+ Revision: 228716
- Update patch0 for new xdm Xsession path (Mdv bug #41645)

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Tue Jun 03 2008 Frederic Crozat <fcrozat@mandriva.com> 2.20.6-2mdv2009.0
+ Revision: 214499
- Patch14: fix invalid free (fix remaining issue from GNOME bug #517526)
- Make package easily backportable on 2008.1

  + Pixel <pixel@mandriva.com>
    - adapt to %%_localstatedir now being /var instead of /var/lib (#22312)

* Tue May 13 2008 Götz Waschk <waschk@mandriva.org> 2.20.6-1mdv2009.0
+ Revision: 206547
- new version
- rediff patch 0

* Wed Apr 09 2008 Götz Waschk <waschk@mandriva.org> 2.20.5-1mdv2009.0
+ Revision: 192475
- new version

* Tue Mar 11 2008 Frederic Crozat <fcrozat@mandriva.com> 2.20.4-3mdv2008.1
+ Revision: 185606
- Patch13: grab translation for Welcome banner from gtk+mdk until upstream has enough translation for it

* Tue Mar 11 2008 Götz Waschk <waschk@mandriva.org> 2.20.4-2mdv2008.1
+ Revision: 184838
- new version

* Mon Mar 10 2008 Götz Waschk <waschk@mandriva.org> 2.20.4-1mdv2008.1
+ Revision: 183930
- new version
- rediff patch 0
- drop patch 11

* Wed Mar 05 2008 Frederic Crozat <fcrozat@mandriva.com> 2.20.3-3mdv2008.1
+ Revision: 180168
- Patch11 : check for both Remote and Locale welcome message when trying to translate it
- Patch12: improve face browser
- Update patch0 to use new background color
- Add symlink for additional Mandriva graphical theme without user list

  + Götz Waschk <waschk@mandriva.org>
    - remove menu scripts

* Mon Jan 21 2008 Frederic Crozat <fcrozat@mandriva.com> 2.20.3-2mdv2008.1
+ Revision: 155868
- Update patch4 to sync with Fedora pam file and call gnome-keyring pam module if present
- Add PolicyKit file to allow sound output for gdm user (needed for accessibility)

* Tue Jan 08 2008 Götz Waschk <waschk@mandriva.org> 2.20.3-1mdv2008.1
+ Revision: 146374
- new version

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

* Tue Nov 27 2007 Götz Waschk <waschk@mandriva.org> 2.20.2-1mdv2008.1
+ Revision: 113356
- new version
- rediff patch 7
- drop patch 9
- update file list

  + Thierry Vignaud <tv@mandriva.org>
    - explain why we require drakx-kbd-mouse-x11

* Mon Nov 26 2007 Frederic Crozat <fcrozat@mandriva.com> 2.20.1-4mdv2008.1
+ Revision: 112142
- Replace drakxtools-newt dependency with drakx-kbd-mouse-x11, to ensure XFdrake is always installed

* Mon Nov 19 2007 Frederic Crozat <fcrozat@mandriva.com> 2.20.1-3mdv2008.1
+ Revision: 110478
- Patch9 (SVN): fixes XDMCP client (Mdv bug #35522)
- Patch10: No longer default to locale value in gdm language list, force UTF-8 by default except for zh (like installer) (Mdv bug #35133)

* Tue Oct 16 2007 Frederic Crozat <fcrozat@mandriva.com> 2.20.1-2mdv2008.1
+ Revision: 98925
- Remove patch9, no longer needed

* Tue Oct 16 2007 Götz Waschk <waschk@mandriva.org> 2.20.1-1mdv2008.1
+ Revision: 98884
- new version
- rediff patch 9
- drop patch 10

* Wed Sep 19 2007 Frederic Crozat <fcrozat@mandriva.com> 2.20.0-2mdv2008.0
+ Revision: 90800
- Patch9 : fix .dmrc handling (Mdv bug #33755)
- Patch10 (SVN): prevent lockup when at-spi / prefetch (GNOME bug #473480) (SVN)

* Mon Sep 17 2007 Götz Waschk <waschk@mandriva.org> 2.20.0-1mdv2008.0
+ Revision: 89336
- new version

* Mon Sep 17 2007 Frederic Crozat <fcrozat@mandriva.com> 2.19.8-4mdv2008.0
+ Revision: 89273
- Fix regression introduced in patch0 (Mdv bug #33645)

* Fri Sep 07 2007 Frederic Crozat <fcrozat@mandriva.com> 2.19.8-3mdv2008.0
+ Revision: 81913
- Patch8:  don't set GDM_LANG for default system locale (Mdv bug #31290)

* Fri Sep 07 2007 Frederic Crozat <fcrozat@mandriva.com> 2.19.8-2mdv2008.0
+ Revision: 81437
- Fix Buildrequires
- Enable remote secure connection (via ssh)
- Update default config patch to remove many duplicated settings which are already in /etc/X11/Xsession (and might cause problems). Ensure background is not reset to color when set to background+color

* Thu Sep 06 2007 Götz Waschk <waschk@mandriva.org> 2.19.8-1mdv2008.0
+ Revision: 80600
- new version

* Mon Sep 03 2007 Frederic Crozat <fcrozat@mandriva.com> 2.19.7-2mdv2008.0
+ Revision: 78574
- Patch7: fix path for gdmsetup in .desktop file
- Don't complain when upgrading if gdm isn't running

* Tue Aug 28 2007 Götz Waschk <waschk@mandriva.org> 2.19.7-1mdv2008.0
+ Revision: 72368
- new version

* Tue Aug 21 2007 Frederic Crozat <fcrozat@mandriva.com> 2.19.6-2mdv2008.0
+ Revision: 68532
- add Source5: add dbus permission for consolekit calls (Mdv bug #32571)
- Fix BR and use Xephyr instead of Xnext for Xnest flexiserver (Mdv bug #29950)

* Thu Aug 16 2007 Götz Waschk <waschk@mandriva.org> 2.19.6-1mdv2008.0
+ Revision: 64134
- new version
- update buildrequires

* Mon Jul 30 2007 Götz Waschk <waschk@mandriva.org> 2.19.5-1mdv2008.0
+ Revision: 56729
- new version

  + Frederic Crozat <fcrozat@mandriva.com>
    - Enable ConsoleKit support

* Tue Jul 10 2007 Götz Waschk <waschk@mandriva.org> 2.19.4-1mdv2008.0
+ Revision: 50888
- new version
- rediff patch 0

* Mon Jun 18 2007 Götz Waschk <waschk@mandriva.org> 2.19.3-1mdv2008.0
+ Revision: 40732
- new version
- new version
- rediff patches 0,1,4,5,6
- drop patches 2,7
- drop legacy menu
- update file list

  + Anssi Hannula <anssi@mandriva.org>
    - rebuild with correct optflags

* Tue May 29 2007 Götz Waschk <waschk@mandriva.org> 2.18.2-1mdv2008.0
+ Revision: 32376
- new version

* Tue Apr 17 2007 Götz Waschk <waschk@mandriva.org> 2.18.1-1mdv2008.0
+ Revision: 13863
- new version

